
/**
 * Example of BubbleSort code.
 *
 * @author adapted from: Robert LaFore, Data Structures and Algorithms in Java
 * @version (2nd edition)
 */
public class BubbleSort
{
   private int[] a;                 // ref to array a
   private int numberElements;      // number of data items
//--------------------------------------------------------------
   public BubbleSort(int max)          // constructor
      {
      a = new int[max];                 // create the array
      numberElements = 0;                        // no items yet
      }
//--------------------------------------------------------------
   public void insert(int value)    // put element into array
      {
      a[numberElements] = value;    // insert it
      numberElements++;             // increment size
      }
//--------------------------------------------------------------
   public String toString()             // displays array contents
      {
      String s = "";
      for(int j=0; j<numberElements; j++) // for each element,
         s += a[j] + " "; 
      s+= '\n';
      return s;
      }
//--------------------------------------------------------------
   public void sort()
      {
      int backwards, forwards;

      for(backwards=numberElements-1; backwards>1; backwards--)   // outer loop (backward)
         for(forwards=0; forwards<backwards; forwards++)        // inner loop (forward)
            if( a[forwards] > a[forwards+1] )       // out of order?
               swap(forwards, forwards+1);          // swap them
      }  // end Sort()
//--------------------------------------------------------------
   private void swap(int index1, int index2)
      {
      int temp = a[index1];
      a[index1] = a[index2];
      a[index2] = temp;
      }
//--------------------------------------------------------------
public static void main(String[] args)
      {
      int maxSize = 100;            // array size
      BubbleSort arr;                 // reference to array
      arr = new BubbleSort(maxSize);  // create the array

      arr.insert(77);               // insert 10 items
      arr.insert(99);
      arr.insert(44);
      arr.insert(55);
      arr.insert(22);
      arr.insert(88);
      arr.insert(11);
      arr.insert(00);
      arr.insert(66);
      arr.insert(33);
      System.out.println("List of unsorted numbers:\n");
      System.out.println(arr);
      

      arr.sort();             // bubble sort them
      
      System.out.println("After bubble sort:\n");
      System.out.println(arr);
   }
}
